//############################################################################
//
// LaserBoy !!!
//
// by James Lehman
// Extra Stimulus Inc.
// james@akrobiz.com
//
// began: October 2003
//
//############################################################################
#ifndef __EZ_UAIL_GUI_DEFINITIONS__
#define __EZ_UAIL_GUI_DEFINITIONS__

//############################################################################
#include "ez_uail_app.hpp"

//############################################################################
class ez_uail_gui : public ez_uail_app
{
public:
    ez_uail_gui(u_int xres, u_int yres);
    //------------------------------------------------------------------------
virtual
   ~ez_uail_gui();
    //------------------------------------------------------------------------
    void           load_cfg_file();
    void           save_cfg_file();
    //------------------------------------------------------------------------
    ez_uail_gui& operator = (const ez_uail_frame_set& frames)
                    {
                        ez_uail_frame_set::clear();
                        ez_uail_frame_set::reserve(frames.size());
                        ez_uail_frame_set::insert(ez_uail_frame_set::end(), frames.begin(), frames.end());
                        renumber();
                        return *this;
                    }
    //------------------------------------------------------------------------
    void           display_stats()
                        {
                            ez_uail_frame_set::display_stats();
                            ez_palette_set::display_stats();
                            return;
                        }
    //------------------------------------------------------------------------
    void           simplify_view_angle()
                        {
                            while(view_angle.x < 0)
                                view_angle.x += two_pi;
                            while(view_angle.x > two_pi)
                                view_angle.x -= two_pi;

                            while(view_angle.y < 0)
                                view_angle.y += two_pi;
                            while(view_angle.y > two_pi)
                                view_angle.y -= two_pi;

                            while(view_angle.z < 0)
                                view_angle.z += two_pi;
                            while(view_angle.z > two_pi)
                                view_angle.z -= two_pi;
                        }
    //------------------------------------------------------------------------
    void           display                         (string ui_message = "" );
    string         display_prompt_and_echo_name    (string prompt          );
    string         display_prompt_and_echo_string  (string prompt          );
    float          display_prompt_and_echo_float   (string prompt          );
    int            display_prompt_and_echo_int     (string prompt          );
    int            display_prompt_and_echo_nibble  (string prompt          );    
    bool           display_prompt_and_echo_bool    (string prompt          );
    void           display_program_menu            ();
    void           display_please_wait             ();
    void           display_in_file_type_menu       ();
    void           display_in_ild_action_menu      ();
    void           display_in_dxf_action_menu      ();
    void           display_in_wave_action_menu     ();
    void           display_in_bmp_action_menu      ();
    void           display_if_not_z_options        ();
    void           display_in_pal_action_menu      ();
    void           display_out_file_type_menu      ();
    void           display_settings_menu           ();
    void           display_veiw_menu               ();    
    void           display_visuals_menu            ();
    void           display_palette_tranz_menu      ();
    void           display_frame_set_tranz_menu    ();
    void           display_frame_tranz_menu        ();
    void           display_draw_color_blank_menu   ();
    void           display_move_scale_rotate_menu  ();
    void           display_wave_utilities_menu     ();
    void           display_wave_show_settings_menu ();
    void           display_wave_stats              (string file_name       );
    //------------------------------------------------------------------------
    short          display_wave_signal_polarities  (string file_name,
                                                    int signal_polarity[8]
                                                   );
    //------------------------------------------------------------------------
    void           display_wave                    (string file_name       );
    //------------------------------------------------------------------------
    void           display_LaserBoy_wave           (ifstream&      in,
                                                    ez_wave_header header
                                                   );
    //------------------------------------------------------------------------
    void           display_unframed_wave           (ifstream&      in,
                                                    ez_wave_header header
                                                   );
    //------------------------------------------------------------------------
    void           display_wave_offsets            ();
    void           display_bit_resolution_settings ();
    void           display_file_list               (string directory       );
    void           display_directory_list          (string directory       );
    //------------------------------------------------------------------------
    void           load_background_bitmap          (struct ezfb_bitmap* bmp);
    void           load_background_bitmap          (string file            );
    void           clear_background_bitmap         ();
    void           recolor_background              ();
    //------------------------------------------------------------------------
    void           display_frame_effects           ();
    void           display_frame_set_effects       ();
    //------------------------------------------------------------------------
struct
    ezfb_bitmap    bmp                    , // a memory clone of screen
                   background             , // empty for clearing screen
                   background_bmp         ; // possibly a bitmap picture
    //------------------------------------------------------------------------
    string         bg_file_name           ;                          
    //------------------------------------------------------------------------
    ez_color       bg_color               ;
    //------------------------------------------------------------------------
    int            font_size_factor       ,
                   move_points_per_key    ;
    //------------------------------------------------------------------------
    ez_3D_float    fulcrum                ,
                   view_angle             ,
                   view_scale             ,
                   view_offset            ;
    //------------------------------------------------------------------------
    float          rotate_radians_per_key , // in radians!
                   scale_per_key          ,
                   scale_up_per_key       ,
                   scale_dn_per_key       ;
    //------------------------------------------------------------------------
    bool           show_points            ,
                   show_blanking          ,
                   show_cursors           ,
                   show_palettes          ,
                   show_stats             ,
                   show_fixed_bounds      ,
                   show_fixed_origin      ,
                   show_floating_axis     ,
                   show_floating_bounds   ,
                   show_ui_message        ,
                   show_fulcrum           ,
                   show_effects_generation,
                   show_background_bitmap ,
                   loop_animation         ,
                   approximate_frame_rate ,
                   wave_show_points       ,
                   wave_show_blanks       ,
                   wave_real_time         ,
                   wave_show_inverted     ,
                   wave_clean_screen      ,
                   wave_loop              ,
                   process_exception      ;
    //------------------------------------------------------------------------
};

//############################################################################
extern ez_uail_gui* AIL;    // declaration of the one and only!
extern SDL_Surface* screen; // declaration of an SDL graphics window
extern SDL_Event    event;

//############################################################################
#endif

//############################################################################
//////////////////////////////////////////////////////////////////////////////
//############################################################################
